Here's a checklist of my immediate plans for the future. If you have an idea for a feature, feel free to make an issue.

# v1.3.3
Want to get sound working this release.

* [x] Get sound playing with a simple sound effect.
	* [x] Generate the sound effect.
		* [x] Create the samples.
		* [x] Save it to a WAV file.
	* [x] Load the WAV file.
	* [x] Play it using the `rodio` crate.
* [x] More advanced sound.
	* [x] Start creating sound effect for the bullet being fired.
		* [x] Create convenience method for generating sound effects.
		* [x] Get started.
	* [x] Create `Sounds` struct.
	* [x] Play it when a player fires a bullet.
		* [x] Get started.
		* [x] Play it when the bullet is fired before `SmoothWorld` is given a chance to predict it.
			* [x] Get started.
			* [x] Fix things.
				Note that most if not all of the time the sound doesn't play on the other client.
		* [ ] ~Possibly delay sounds based on which update they happen.~
			This will make things play better on low frame rates and high fire rates, but I can't be bothered.
	* [x] Improve bullet sound.
	* [x] Polish the bullet sound.
	* [x] Replace `rodio` with `kira`.
	* [x] Get spatial audio working.
		* [x] Get started.
		* [x] Customise the attenuation.
		* [x] Polishes with the camera and attenuation.
		* [x] Doppler effect.
	* [x] Try varying the speed by a random amount each time it's played.
	* [x] Test when bullets are fired at a very high rate, and make improvements if needed.
* [x] Create and play more sound effects.
	* [x] Player hit.
		* [x] Get a basic hit sound working.
		* [x] Refactor code to handle multiple sound effects.
		* [x] Play it when a player gets hit.
		* [x] Polish the sound.
	* [x] Player killed.
		* [x] Get basic sound working.
			* [x] Refactor with resampler.
			* [x] Create Brownian noise and use it to make an explosion sound.
		* [x] Add it to the game.
		* [x] Have it played not spatially when you die.
		* [x] Polish the sound.
		* [x] Even more polishes.
	* [x] Decreased volume for non-spatial sounds.
	* [x] Bullet hits block.
		* [x] Play sound when this happens.
			* [x] Play this in `SmoothWorld::update`.
			* [x] Edge cases.
				* [x] When the bullet is fired in the `World` and collides before being added to `SmoothWorld`.
				* [x] When the (not fake) bullet is fired in the `World` and collides during `SmoothWorld::sync`.
				* [x] Mitigate problems with time shift.
		* [x] Start creating sound effect.
		* [x] Improve it.
		* [x] Polish it.
		* [x] Change sound effect velocity to zero.
	* [x] Ammo crate collection.
		* [x] Play sound.
		* [x] Create basic sound effect.
		* [x] Improve it.
		* [x] Polish it.
		* [x] More polishes.
	* [x] Effect applied (powerup collected or collision with special area).
		* [x] Generate very simple effect/teleportation sounds.
		* [x] Play those sounds when appropriate.
			* [x] Powerups.
				* [x] Get started.
				* [x] Play teleportation sounds from the followed player non-spatially.
			* [x] Effect zones.
		* [x] Speed.
			* [x] Get started.
			* [x] Improve it.
			* [x] Polishes.
		* [x] Normalise amplitudes.
		* [x] Reload.
			* [x] Get started.
			* [x] Improve it.
			* [x] Polishes.
		* [x] Health/regeneration.
			* [x] Get started.
			* [x] Improve it.
			* [x] Polish it.
		* [x] Damage.
			* [x] Get started.
			* [x] Improve it.
			* [x] Polishes.
		* [x] Forcefield.
			* [x] Get started.
			* [x] Improve it.
			* [x] Polishes.
	* [x] Teleportation (powerup ~or portal~).
		* [x] Get started.
		* [x] Improve it.
		* [x] Polishes.
	* [ ] ~Only play non-powerup effect sound if new power > 1.~
		Nevermind, this was intended to avoid playing sounds when increasing the underpower of a given effect, but that won't fully work if an effect is already active.
* [x] Support looping sounds.
	* [x] Generate a very simple looping sound effect (like a sine wave).
	* [x] Play that sound effect while something is happening.
	* [x] Allow updating the position of this sound.
	* [x] Move the source around.
	* [x] Get the Doppler effect working.
	* [x] Resolve all TODOs.
	* [x] Ensure sounds don't continue to play when the player leaves the playing state.
* [x] Have non-spatial sounds play at decreased volume for zoomed out camera.
* [x] Create and play looping sounds.
	* [x] Player thrust.
		* [x] Start working on the sound effect.
		* [x] Get it playing.
		* [x] Improve it.
		* [x] Polishes.
	* [ ] ~Forcefield.~
		* [ ] ~Idle.~
		* [ ] ~Deflection.~
	* [x] Player hits block.
		* [x] Create basic sound.
		* [x] Get it playing.
		* [x] Improve it.
		* [x] Polishes.
			* [x] To the sound.
			* [x] How it's played.
* [x] Prevent ammo crates from spawning near players.
* [x] Prevent playing effect sounds when new players join (especially important if the server config has an effect zone covering the entire map).
* [x] GUI to control sound volume, or completely disable it.
	* [x] Add to config.
	* [x] Use the value in the config.
	* [x] Create GUI.
* [x] Prevent chat from being opened while HUD is hidden.
* [x] Update documentation to mention sound.

# v1.4.0
* [ ] Play teleportation sounds when teleporting with portals.
	* [ ] Have `PlayerPos` events indicate the type of teleportation.
* [ ] Change forcefield strength distribution to more accurately model the animation.
* [ ] Add extension data to protocol.
* [ ] Update documentation with new screenshots.
* [ ] Update SERP version.
